<?php
header('Access-Control-Allow-Origin: https://www.ftppro.com');
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TO DO: After editing the following variables, upload this file to the 'public_html' directory on your server
///////////////////////////////////////////////////////////////////////////////////////////////////////////////

// FTPPro requires a Premium membership at BusinessSearchIndex.com. Replace both '= 0' assignments, with the UserID and Password that you use at BusinessSearchIndex.com:
$gcsBusinessSearchIndex_UserID = 0;
$gcsBusinessSearchIndex_Password = "0";

// Replace the '= 0' assignment in the next variable, with any FTPPro Password that you choose (1 to 12 characters). This Password must be entered at FTPPro.com, to access this script:
$gcsFTPProPassword = "0";

// The next optional variable adds additional protection. If you want this script to only be accessible from one IP Address, then assign the next variable to your IP Address:
$csValidIPAddress = "";

////////////////////////
// TO DO: End of section
////////////////////////

if ($csValidIPAddress && ($_SERVER['REMOTE_ADDR'] != $csValidIPAddress)) {
	echo -2;
	exit;
}

/////////////////////////////////////////////////////
$sPostData = file_get_contents('php://input');
$objJson = json_decode($sPostData);
$sPassword = substr(htmlspecialchars(trim($objJson->sPassword)),0,20);			
if ($sPassword != $gcsFTPProPassword) {
	echo -1;
	exit;
}

$gcsServerAction_GetDirectory_AllInfo = 1;
$gcsServerAction_GetDirectory_RecursiveFilepaths = 2;
$gcsServerAction_UploadFile = 3;
$gcsServerAction_DownloadFile = 4;
$gcsServerAction_ChangeFilePermissions = 5;
$gcsServerAction_ChangeOwnerName = 6;
$gcsServerAction_ChangeOwnerGroup = 7;
$gcsServerAction_RenameFile = 8;
$gcsServerAction_DeleteFile = 9;
$gcsServerAction_MakeDirectory = 10;
$gcsServerAction_RemoveDirectory = 11;
$gcsServerAction_GetBSIInfo = 12;
$gcsServerAction_GetAccessLogs = 13;


if ($objJson->nServerActionID == $gcsServerAction_GetDirectory_AllInfo) {
	if ($objJson->sPath != '') {
		echo shell_exec("cd " . $objJson->sPath . "; pwd; ls -la --time-style=long-iso");
	} else {
		echo shell_exec("pwd; ls -la --time-style=long-iso");
	}
}

if ($objJson->nServerActionID == $gcsServerAction_GetDirectory_RecursiveFilepaths) {
	echo shell_exec("find " . $objJson->sPath . " -type f -printf '%p\t%s\n'");
}

if ($objJson->nServerActionID == $gcsServerAction_UploadFile) {
	@DoUploadFile();	
}
if ($objJson->nServerActionID == $gcsServerAction_DownloadFile) {
	@DoDownloadFile();	
}

if ($objJson->nServerActionID == $gcsServerAction_ChangeFilePermissions) {
	@DoChangeFilePermissions();	
}

if ($objJson->nServerActionID == $gcsServerAction_ChangeOwnerName) {
	@DoChangeOwnerName();	
}

if ($objJson->nServerActionID == $gcsServerAction_ChangeOwnerGroup) {
	@DoChangeOwnerGroup();	
}

if ($objJson->nServerActionID == $gcsServerAction_RenameFile) {
	@DoRenameFile();	
}

if ($objJson->nServerActionID == $gcsServerAction_DeleteFile) {
	@DoDeleteFile();	
}

if ($objJson->nServerActionID == $gcsServerAction_MakeDirectory) {
	@DoMakeDirectory();	
}

if ($objJson->nServerActionID == $gcsServerAction_RemoveDirectory) {
	@DoRemoveDirectory();	
}

if ($objJson->nServerActionID == $gcsServerAction_GetBSIInfo) {
	echo "$gcsBusinessSearchIndex_UserID;$gcsBusinessSearchIndex_Password";
}

if ($objJson->nServerActionID == $gcsServerAction_GetAccessLogs) {
	$sCommand = 'awk \'NR<=100000 { print }\' /usr/local/apache/domlogs/' . $objJson->sDomain . '-ssl_log';
	echo shell_exec($sCommand);
}

///////////////////////////////////////////////
function DoMakeDirectory() {
	global $objJson;
	echo mkdir($objJson->sFilePath, 0755, TRUE);
}
///////////////////////////////////////////////
function DoRemoveDirectory() {
	global $objJson;
	rrmdir($objJson->sFilePath);
	echo 1;
}
///////////////////////////////////////////////
function rrmdir($dir) {
	if ($dir != "") {
		$objects = scandir($dir);
		foreach ($objects as $object) { 
			if ($object != "." && $object != "..") { 
				if (is_dir($dir . "/" . $object) && !is_link($dir . "/" . $object))
					rrmdir($dir . "/" . $object);
				else
					unlink($dir. "/" . $object); 
			} 
		}
		rmdir($dir);
	}
}
///////////////////////////////////////////////
function DoUploadFile() {
	global $objJson;

	if ($objJson->sFinalPath == "0") {
		file_put_contents($objJson->sTempPath, $objJson->sData, FILE_APPEND);
	} else {
		$objData = base64_decode(file_get_contents($objJson->sTempPath));
		file_put_contents($objJson->sFinalPath, $objData);
		unlink($objJson->sTempPath);
	}
	echo 1;
}
///////////////////////////////////////////////
function DoDownloadFile() {
	global $objJson;
	if ($objJson->nFileOffset == 0) {
		$sB64 = base64_encode(file_get_contents($objJson->sFilePath));
		file_put_contents($objJson->sTempPath, $sB64);
		echo strlen($sB64);
	} else {
		if ($objJson->nFileOffset == 1) {
			$objJson->nFileOffset = 0;
		}
		$sB64_chunk = file_get_contents($objJson->sTempPath, false, NULL, $objJson->nFileOffset, $objJson->nFileChunkSize);
		echo $sB64_chunk;
		if (strlen($sB64_chunk) != $objJson->nFileChunkSize) {
			unlink($objJson->sTempPath);
		}
	}
}
///////////////////////////////////////////////
function DoChangeFilePermissions() {
	global $objJson;
	echo chmod($objJson->sFilePath, octdec("0" . $objJson->sPermissions));
}	
///////////////////////////////////////////////

///////////////////////////////////////////////
function DoChangeOwnerName() {
	global $objJson;
	echo chown($objJson->sFilePath, $objJson->sNewOwnerName);
}	
///////////////////////////////////////////////

///////////////////////////////////////////////
function DoChangeOwnerGroup() {
	global $objJson;
	echo chgrp($objJson->sFilePath, $objJson->sNewOwnerGroup);
}	
///////////////////////////////////////////////

///////////////////////////////////////////////
function DoRenameFile() {
	global $objJson;
	echo rename($objJson->sFilePath, $objJson->sNewFilepath);
}
///////////////////////////////////////////////

///////////////////////////////////////////////
function DoDeleteFile() {
	global $objJson;
	echo unlink($objJson->sFilePath);
}
///////////////////////////////////////////////

?>
